Support for BeeGFS
==================

The BeeGFS community edition is available free of charge and shares a common codebase with our
[enterprise edition](https://www.beegfs.io/c/enterprise/enterprise-features/). The enterprise
edition includes support alongside additional features, and is how we fund ongoing BeeGFS
development. Regardless of whether you use the paid or community edition, we welcome [GitHub
issues](https://github.com/ThinkParQ/beegfs/issues) for bugs and feature requests from everyone in
our community.

**Please note:** GitHub issues are not the place for general questions on how to deploy or use
BeeGFS. Refer to the resources below. If you are unsure if your issue is a bug or "working as
designed," feel free to open an issue, and we will politely direct you to community support options
if necessary.

Thank you for being part of the BeeGFS community!

### Documentation

* [BeeGFS Documentation Site](https://doc.beegfs.io).
* [Building BeeGFS from sources](README.md) (for developers).

### Community Support

BeeGFS is fortunate to have an active community of users who are often willing to help with general
questions on designing, deploying, and otherwise administering BeeGFS.

* [BeeGFS Google Groups](https://groups.google.com/g/fhgfs-user).
* [GitHub Discussions](https://github.com/ThinkParQ/beegfs/discussions).

While our team moderates these forums to ensure posts are on-topic and meet our [Code of
Conduct](code-of-conduct.md), we generally do not actively respond to posts. However, we are always
keeping an eye out for ways to improve BeeGFS and our documentation.

### Enterprise Support

The BeeGFS enterprise edition offers:

- Dedicated support from BeeGFS experts.
- Access to features not available in the community edition such as storage pools and quotas.
- Assistance with designing, deploying, and managing BeeGFS.

If you are a current BeeGFS enterprise customer with a valid support contract, please contact our
support team via the channels specified in your support contract documentation.

If you are interested in enterprise support, professional services, or learning more about the
additional features of the enterprise edition, please contact us at
[info@thinkparq.com](mailto:info@thinkparq.com).
